/*
 *  malloc_test - Memory allocation tester
 *  Copyright (C) 2011 Jaromir Capik <tavvva@email.cz>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
  size_t i;
  char *a;
  size_t size_in_mb, size_in_b;

  if (argc!=2) {
    fprintf(stderr,"Usage: malloc_test <size_in_MB>\n");
    exit(EXIT_FAILURE);
  }

  size_in_mb = atoi(argv[1]);
  size_in_b = size_in_mb * 1024 * 1024;

  printf("Allocating %u MB of memory ...\n",size_in_mb);

  a = (char *)malloc(size_in_b);

  if (a == NULL) {
    fprintf(stderr,"failed! Exiting.\n");
    exit(EXIT_FAILURE);
  }

  /* this is really needed */
  for (i=0;i<size_in_b;i++) a[i]=0;

  printf("done...\nPress ENTER to release it and exit ...\n");

  getchar();

  free(a);

  return(EXIT_SUCCESS);
}
